//
//  CMFBMViewController.m
//  BigMessage
//
//  Created by Christopher Farrell on 4/4/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CMFBMViewController.h"
#import "UITextView+PinchZoom.h"

@interface CMFBMViewController ()

@property (nonatomic)BOOL isColorForFont;
@end

@implementation CMFBMViewController

- (void)viewDidLoad
{
    puts("viewDidLoad");
    [super viewDidLoad];
    
    self.landscapeFrame = CGRectMake(0.0, 0.0, self.view.frame.size.height, self.view.frame.size.width);

    [self addScrollViewUI];
    [self addTextViewUI];
    
    [self addSegmentdControlUI];
    [self addColorPickerUI];
    
    [self addTextFieldUI];
     

}
-(void)addTextFieldUI{
    CGRect frame = CGRectMake(0.0, 0.0, self.landscapeFrame.size.width, 25.0 );
    self.textField = [[UITextField alloc]initWithFrame:frame];
    
    self.textField.borderStyle = UITextBorderStyleNone;
    self.textField.textAlignment = NSTextAlignmentCenter;
    self.textField.backgroundColor = [UIColor blackColor];
    self.textField.textColor = [UIColor whiteColor];
    
    self.textField.placeholder = @"BEER ME!";
    self.textField.text = @"BEER ME!";
    
    self.textField.enablesReturnKeyAutomatically = YES;
    self.textField.returnKeyType = UIReturnKeyDone;
    [self.textField becomeFirstResponder];
    self.textField.delegate = self;
    [self.view addSubview:self.textField];
    
    UIPanGestureRecognizer* panRecognizer = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(handlePan:)];
    [self.view addGestureRecognizer:panRecognizer];
    
    
}
-(void)addScrollViewUI{
    self.scrollView = [[UIScrollView alloc] initWithFrame:self.landscapeFrame];
    [self.view addSubview:self.scrollView];
}
-(void)addColorPickerUI{
    self.colorPicker = [[FCColorPickerViewController alloc]
                        initWithNibName:nil
                        bundle:nil];
    self.colorPicker.color = self.view.backgroundColor;
    self.colorPicker.delegate = self;
    [self.colorPicker setModalPresentationStyle:UIModalPresentationFormSheet];
}
-(void)addSegmentdControlUI{
    self.segmentedControl = [[HMSegmentedControl alloc] initWithSectionTitles:@[@"Background Color", @"Font Color", @"Text"]];
    [self.segmentedControl setFrame:CGRectMake(0.0, self.view.frame.size.width - 30, self.view.frame.size.height, 30.0)];
    [self.segmentedControl addTarget:self action:@selector(segmentedControlChangedValue:) forControlEvents:UIControlEventValueChanged];
    [self.segmentedControl setBackgroundColor:[UIColor lightGrayColor]];
    [self.segmentedControl setSelectedSegmentIndex:-1];

    [self.view addSubview:self.segmentedControl];
}
-(void)addTextViewUI{
    self.textView = [[UITextView alloc] initWithFrame:self.landscapeFrame];
    self.textView.backgroundColor = [UIColor clearColor];
    self.textView.text = @"BEER ME!";
    self.textView.font = [UIFont systemFontOfSize:134.0];
    self.textView.textColor = [UIColor redColor];
    //self.textView.
    self.textView.zoomEnabled = YES;
    self.textView.minFontSize = 40;
    self.textView.maxFontSize = 240;
    [self.textView setEditable:NO];

    
    [self.scrollView addSubview:self.textView];
    
    /*
    UITapGestureRecognizer* tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTap:)];
    tapRecognizer.numberOfTapsRequired = 1;
    tapRecognizer.numberOfTouchesRequired = 1;
    [self.textView addGestureRecognizer:tapRecognizer];
     */
}

-(void)segmentedControlChangedValue:(HMSegmentedControl *)segmentedControl{
    NSLog(@"Selected index %i (via UIControlEventValueChanged)", segmentedControl.selectedSegmentIndex);
    switch(segmentedControl.selectedSegmentIndex){
        case 0:
            self.isColorForFont = NO;
            [self presentViewController:self.colorPicker animated:YES completion:nil];
            break;
        case 1:
            self.isColorForFont = YES;
            [self presentViewController:self.colorPicker animated:YES completion:nil];
            break;
        case 2:
            self.textField.hidden = NO;
            [self.textField becomeFirstResponder];
            break;
    }
    [self.segmentedControl setSelectedSegmentIndex:-1];
    
}
-(void)colorPickerViewController:(FCColorPickerViewController *)colorPicker didSelectColor:(UIColor *)color {
    
    [self dismissViewControllerAnimated:YES completion:nil];
    if(self.isColorForFont){
        self.textView.textColor = color;
    }else{
        self.view.backgroundColor = color;
    }

}

-(void)colorPickerViewControllerDidCancel:(FCColorPickerViewController *)colorPicker {
    [self dismissViewControllerAnimated:YES completion:nil];
}

- (void)handleTap:(UITapGestureRecognizer*)recognizer
{
    if (recognizer.state == UIGestureRecognizerStateEnded)
    {
        puts("UIGestureRecognizerStateEnded");
       //[self.textEditor dismiss];
        
    }
}
- (void)handlePan:(UIPanGestureRecognizer*)recognizer
{
    puts("UIPanGestureRecognizer");
    if (recognizer.state == UIGestureRecognizerStateEnded)
    {
        puts("UIGestureRecognizerStateEnded");
        
        if(self.segmentedControl.isHidden){
            self.segmentedControl.hidden = NO;
        }else{
           self.segmentedControl.hidden = YES;
        }
        
    }
}

- (void) viewWillAppear:(BOOL)animated
{
    puts("viewWillAppear");
    [super viewWillAppear:animated];
    
    
  
}

- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if(UIInterfaceOrientationIsPortrait(interfaceOrientation)){
        return NO;
    }
    return YES;
}

#pragma mark - UITextFieldDelegate

- (void)textFieldDidEndEditing:(UITextField *)textField{
    
    self.textView.text = textField.text;
    [self.textField resignFirstResponder];
    self.textField.hidden = YES;
}
- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string{
    puts("shouldChangeTextInRange");
    if([string isEqualToString:@"\n"]) {
        [textField resignFirstResponder];
        return NO;
    }
    return YES;
}




@end
